VERSION 5.00
Begin VB.Form XcodeTest 
   Caption         =   "Xapi Code Version Reader"
   ClientHeight    =   735
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   Icon            =   "XcodeTest.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   735
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton ReadCV 
      Caption         =   "&Read Code Version"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   1575
   End
   Begin VB.Frame StatusFrame 
      Caption         =   "Status"
      Height          =   615
      Left            =   1800
      TabIndex        =   0
      Top             =   0
      Width           =   2775
      Begin VB.Label StatusBox 
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   2415
      End
   End
End
Attribute VB_Name = "XcodeTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' XcodeTest form implementation - as simple as it can be :)
'

' Global control block
Dim mailbox_struct As CBlock

' What we need to do here is to initialize library and register card 0
Private Sub Form_Load()
        
    ' Intialize library
    If XAPISetupVB = 0 Then
        MsgBox "Can not initialize the library. Check if the SDLA driver is started.", vbCritical, "XcodeTest"
        End
    End If
    ' Register card
    If XAPIRegisterCardVB(0) = 0 Then
        MsgBox "Can not register card 0. Check if it has been configured.", vbCritical, "XcodeTest"
        ' Clean up library
        XAPICleanupVB
        End
    End If
    
    StatusBox.Caption = "Library and Card 0 are Ready."
    
End Sub

' Just deregister card 0 and cleanup the library
Private Sub Form_Unload(Cancel As Integer)
    XAPIDeregisterCardVB (0)
    XAPICleanupVB
End Sub

' Set up the control block and execute READ_CODE_VERSION
Private Sub ReadCV_Click()
    
    mailbox_struct.command = READ_CODE_VERSION    '   command code
    mailbox_struct.buffer_length = 0              '   buffer length
    
    ' call the board ...
    Call XAPIControlVB(mailbox_struct, 0)
        
    ' check return code and act appropriately
    If Not mailbox_struct.return_code = 0 Then
       StatusBox.Caption = "FAILED to read code version."
    Else
       StatusBox.Caption = "Code version : " & Chr(mailbox_struct.data(0)) & Chr(mailbox_struct.data(1)) & Chr(mailbox_struct.data(2)) & Chr(mailbox_struct.data(3))
    End If

End Sub
