//
// Winhldr8.h - HLDC Protocol-dependent defines and inits for Winhldr8
//
// Win32 vesion for VC4.0++
//

// One and only one of those has to be defined
#define MAKEFORNT
//#define MAKEFOR95

#include "f:\common\apidev\x.25\xapi32mc\xapi32mc.h"

// standard function calls to XAPI32MC.DLL 
#define APIWRITEPORTBYTE(a,b,c)				XAPIWritePortByte(a,b,c)
#define	APIWRITEBYTE(a,b,c)					XAPIWriteByte(a,b,c)
#define	APIREADPORTBYTE(a,b)				XAPIReadPortByte(a,b)
#define	APIREADBYTE(a,b)					XAPIReadByte(a,b)
#define	APISETUP()							XAPISetup()
#define	APICLEANUP()						XAPICleanup()
#define	APIPREPAREFORLOADING(a)				XAPIPrepareForLoading(a)
#define	APILOADCOMPLETE(a)					XAPILoadComplete(a)
#define	APIGETCARDS()						XAPIGetCards()
#define	APIZEROWINDOW(a)					XAPIZeroWindow(a)

#define CODE_BASE_ADDR 						0x100	// the Z80 code base address
#define SIZEOF_VER_NO 						0x04	// the number of bytes in the version number, eg 1.01
#define OFF_CODE_VER_HDLC_CODE 				0x6600	// the offset of the HDLC code version embedded in the actual HDLC

#ifdef MAKEFORNT
char *abouttitle = "About WINXLDR8 v1.0 for WinNT";
char *aboutstatement = "WINXLDR8 for NT - X.25 Code Loader for Sangoma S508 adapter.\nCopyright (c) 1995-1997 Sangoma Technologies Inc.\nJune 1997 release";
#elif defined(MAKEFOR95)
char *abouttitle = "About WINXLDR8 v1.0 for Win95";
char *aboutstatement = "WINXLDR8 for NT - X.25 Code Loader for Sangoma S508 adapter.\nCopyright (c) 1995-1997 Sangoma Technologies Inc.\nJune 1997 release";
#else
// you'll get compilation error
#endif

char *szClassName = "XLOADClass";
char *szTitleName = "WINXLDR8 - X.25 for S508 Loader";
char *iniLoaderSection = "WINXLOAD";
char *iniConfigEntry = "config_file";

