/* XCONFIG.C - Configuration */
/* link to EXE */

// take this out for compiling 16-bit, leave in for 32-bit/registry

#define	MAKEFORNT

#define STRICT

#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <commdlg.h>
#include <winioctl.h>
//#include "d:\xw\xapi_f.h"
#include "resource.h"
#include "drvload.h"
#include "SangstConfig.h"

#define SAYSTATE(x)     SetWindowText(exehwn, x)
#define SAYNOSTATE()    SetWindowText(exehwn, szProgramHeader)

//#define       SAYMSG(x)       AddStringListBox(x)
#define CM_FILESAVE_CONFIGURATION	3
//#define CM_FILEEXIT	2
#define NO_SUCH_VALUE 1000

#define MSG_CLOSEERROR  0x4000
#define IDM_ABOUT       0x1000
#define COUNT_MAX       100

#define MAX_CARDS       16
#define MAX_OPS         30

#define TOP_OP_LINE     36
#define NUM_CONFIG_ENTRIES      38

#define	CAF	7

#define	ADJUST(x)	((x*ca)/CAF)

HINSTANCE ghinstance;
HWND exehwn, hlphwn, exehwn514;
HWND grp_hwn = NULL;
HWND errorhwn = NULL;
HWND ops_hwn[MAX_OPS];
HWND sel_hwn[MAX_OPS];
DLGPROC errorproc, conf514proc;

ALL_514 statinfo;
char DebugString[500];

#ifdef MAKEFORNT
char *abouttitle = "About XCONFIGurator v1.2nt";
char *aboutstatement =
"XCONFIG for NT is Copyright (c) 1995-1996 Sangoma Technologies Inc.\nAugust 1996 release";
char *service_path = "SYSTEM\\CurrentControlSet\\Services\\SDLA";
#else
char *abouttitle = "About XCONFIGurator v1.2";
char *aboutstatement =
"XCONFIG is Copyright (c) 1994-1996 Sangoma Technologies Inc.\nAugust 1996 release";
#endif

//char *szClassName514 = "STCONF";
char CardsInRegistry[16];
BOOL ProgramEntry = TRUE;
WPARAM lastsel = 0;
//char changemade = 0;


char *szClassName = "XCONFClass";
char *szTitleName = "XCONFIGurator";
char szProgramHeader[40];

char *helpname = "xconfig.hlp";

char *logfilter = "Text Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0";

char *our_ini_file = "sdla.ini";
char *iniLoaderSection = "WINXLOAD";
//char *ini502CodeEntry = "code_502";
char *ini502CodeEntry = "code_514";
char *ini502TestEntry = "test_code_502";
char *iniCardSectionBase = "sdla";
char *iniConfigEntry = "config_file";

char *iniWSEntry = "window_segment";
char *iniWOEntry = "window_offset";
char *iniPortEntry = "io_port";

char *iniBusEntry = "BusNumber";
char *iniSlotEntry = "SlotNumber";
char *iniCPUEntry = "CPU";

char *iniSizeEntry = "window_size";
char *iniConfigSection = "XCONFIG";
char *iniDefEntry = "default_directory";
char *iniXAPISection = "XAPI";
char *iniTimeoutEntry = "SDLA_timeout_in_seconds";
char *iniTimestampEntry = "apply_timestamp";
char *iniRetriesEntry = "read_config_retries";


BYTE card = 0;
WORD window_size;
void *mbuff;
WORD mbuff_size;
char testcodefname[80], codefname[80], configfname[80];
HWND aphwn = NULL;
BOOL abort_the_mission = FALSE;
int ca;

//CBLOCK cb, auxb;

BOOL okflag;

char Lidx[] = "!";
char Lvalue[] = "$";
char Ledit[] = "&";
char Lword[] = "+";
char Lmask[] = "#";
char MASKBIT0[] = "1";
char MASKBIT1[] = "2";
char MASKBIT2[] = "4";
char MASKBIT3[] = "8";
char MASKBIT4[] = "16";
char MASKBIT5[] = "32";
char MASKBIT6[] = "64";
char MASKBIT7[] = "128";
char MASKBIT8[] = "256";
char MASKBIT9[] = "512";
char MASKBIT10[] = "1024";
char MASKBIT11[] = "2048";
char MASKBIT12[] = "4096";
char MASKBIT13[] = "8192";
char MASKBIT14[] = "16384";
char MASKBIT15[] = "32768";


char *Sports[] = { "0x250", "0x254", "0x300", "0x304", "0x350", "0x354", "0x360", "0x364", "" };
char *Ssegs[] = { "0xA000", "0xC000", "0xD000", "0xE000", "" };
char *Swins[] = { "0x0000", "0x2000", "0x4000", "0x6000", "0x8000", "0xA000", "0xC000", "" };

char *hard_options[] = {
"I/O port:",
"Shared memory segment:",
"Shared memory window:",
""
};
char **hard_selects[] = {
Sports,
Ssegs,
Swins
};

/*
char *HDLC_options[] = {
"Electrical Interface:",
"Line speed (bps):",
"Station configuration:",
"T1 (period timer):",
"T2 (acknowledgement frames):",
"T4 (supervisory frames):",
"N2 (max. (re)transmissions):",
"k (frame level window size):",
"Modem error clearing:",
"Automatic link level connection:",
"Issue SABM frames during link setup:",
"Re-transmit aborted frames:",
""
};
*/

char *HDLC_options[] = {
"Line speed (bps):",
"Station configuration:",
"T1 (period timer):",
"T2 (acknowledgement frames):",
"T4 (supervisory frames):",
"N2 (max. (re)transmissions):",
"k (frame level window size):",
"Modem error clearing:",
"Automatic link level connection:",
"Issue SABM frames during link setup:",
"Re-transmit aborted frames:",
""
};

char *SElectrInterface[] = { "RS232", "V.35", "" };

char *Sline[] = { "0", "1200", "2400", "4800", "9600", "19200", "38400",
		"45000", "56000", "64000", "74000", "112000", "128000", "" };
char *Sdtedce[] = { "DCE", "DTE", "" };
// ! means a range of numbers: upper limit is second number in text form,
// and third is starting number in text form
char *ST1[] = { Lidx, "30", "1" };
char *ST2[] = { Lidx, "29", "0" };
char *ST4[] = { Lidx, "240", "0" };
char *SN2[] = { Lidx, "30", "1" };
char *Sk[] = { Lidx, "7", "1" };

// # means a bit mask operation allowing two values of selection
// first parameter after # is the decimal value of the bitmask
// second is the option string for a reset bit, third is for set bit
char *Shcopls[] = { Lmask, MASKBIT0, "YES", "NO" };
char *Shcopab[] = { Lmask, MASKBIT1, "YES", "NO" };

char *Sable[] = { "DISABLED", "ENABLED", "" };
/*
char **HDLC_selects[] = { SElectrInterface, Sline, Sdtedce, ST1, ST2, ST4, SN2, Sk,
				Sable, Sable, Shcopls, Shcopab };
*/

char **HDLC_selects[] = { Sline, Sdtedce, ST1, ST2, ST4, SN2, Sk,
				Sable, Sable, Shcopls, Shcopab };

char *x25basic_options[] = {
"Default packet window:",
"Default packet size in bytes:",
"Maximum packet size in bytes:",
"Lowest PVC:",
"Highest PVC:",
"Lowest incoming SVC:",
"Highest incoming SVC:",
"Lowest two-way SVC:",
"Highest two-way SVC:",
"Lowest outgoing SVC:",
"Highest outgoing SVC:",
""
};
char *Spwin[] = { Lidx, "7", "1" };
// + inserted in front of list indicates WORD-width storage, otherwise
// it's BYTE-sized
// $ means the following options are stored by value, not by index
char *Spsize[] = { Lword, Lvalue, "16", "32", "64", "128", "256", "512", "1024", "" };
// & means that the entry field is edit only and must be in the range
// of third parameter->second parameter inclusive
char *SVCrange[] = { Lword, Ledit, "4095", "0" };

char **x25basic_selects[] = { Spwin, Spsize, Spsize, SVCrange, SVCrange,
				SVCrange, SVCrange, SVCrange, SVCrange,
				SVCrange, SVCrange };

char *x25config_options[] = {
"Permit registration pragmatics:",
"DCE issues Diagnostic packets:",
"Issue RESTART on link initialization:",
"Include diagnostic in CLR/RSTRT/RST:",
"Permit D-bit pragmatics:",
"Automatic flow control negotiation:",
"Addr/facility length in CALL ACCEPT:",
"Restricted facilities support:",
""
};

char yes[] = "YES";
char no[] = "NO";
char *Scfgprag[] = { Lword, Lmask, MASKBIT0, no, yes };
char *Scfgdiag[] = { Lword, Lmask, MASKBIT1, yes, no };
char *Scfgrest[] = { Lword, Lmask, MASKBIT2, yes, no };
char *Scfgdifl[] = { Lword, Lmask, MASKBIT3, yes, no };
char *Scfgdbit[] = { Lword, Lmask, MASKBIT4, yes, no };
char *Scfgflow[] = { Lword, Lmask, MASKBIT5, no, yes };
char *Scfgleng[] = { Lword, Lmask, MASKBIT6, yes, no };
char *Scfgfaci[] = { Lword, Lmask, MASKBIT7, yes, no };

char **x25config_selects[] = { Scfgprag, Scfgdiag, Scfgrest, Scfgdifl,
				Scfgdbit, Scfgflow, Scfgleng, Scfgfaci };

char *resp_options[] = {
"Flow control - issuing RR packets:",
"Issuing of Clear Confirmation:",
"Issuing of Reset Confirmation:",
"Issuing of Restart Confirmation:",
"Issuing of Interrupt Confirmation:",
""
};

char automatic[] = "AUTO";
char manual[] = "MANUAL";
char *Srspflow[] = { Lmask, MASKBIT0, "SELECTIVE", "ALWAYS" };
char *Srspclea[] = { Lmask, MASKBIT1, automatic, manual };
char *Srsprese[] = { Lmask, MASKBIT2, automatic, manual };
char *Srsprest[] = { Lmask, MASKBIT3, automatic, manual };
char *Srspinte[] = { Lmask, MASKBIT4, automatic, manual };

char **resp_selects[] = { Srspflow, Srspclea, Srsprese, Srsprest, Srspinte };

char supd[] = "SUPPORTED";
char unsupd[] = "Unsupported";
char *fac1_options[] = {
"Flow control parameter negotiation:",
"Throughput class negotiation:",
"Reverse charging:",
"Fast select (extended format):",
"NUI selection:",
"CUG selection (basic format):",
"CUG selection (extended format):",
"CUG outgoing (basic format):",
"CUG outgoing (extended format):",
"Bilateral CUG selection:",
""
};

char *fac2_options[] = {
"RPOA selection (basic format):",
"RPOA selection (extended format):",
"Call deflection selection:",
"Call redirection or deflection:",
"Called line address modified notif:",
"Transit delay selection/indication:",
"Charging info - requesting service:",
"Charging info - ind. monetary unit:",
"Charging info - ind. segment count:",
"Charging info - ind. call duration:",
""
};

char *s1f0[] = { Lword, Lmask, MASKBIT0, unsupd, supd };
char *s1f1[] = { Lword, Lmask, MASKBIT1, unsupd, supd };
char *s1f2[] = { Lword, Lmask, MASKBIT2, unsupd, supd };
char *s1f3[] = { Lword, Lmask, MASKBIT3, unsupd, supd };
char *s1f4[] = { Lword, Lmask, MASKBIT4, unsupd, supd };
char *s1f5[] = { Lword, Lmask, MASKBIT5, unsupd, supd };
char *s1f6[] = { Lword, Lmask, MASKBIT6, unsupd, supd };
char *s1f7[] = { Lword, Lmask, MASKBIT7, unsupd, supd };
char *s1f8[] = { Lword, Lmask, MASKBIT8, unsupd, supd };
char *s1f9[] = { Lword, Lmask, MASKBIT9, unsupd, supd };
char *s2f0[] = { Lword, Lmask, MASKBIT10, unsupd, supd };
char *s2f1[] = { Lword, Lmask, MASKBIT11, unsupd, supd };
char *s2f2[] = { Lword, Lmask, MASKBIT12, unsupd, supd };
char *s2f3[] = { Lword, Lmask, MASKBIT13, unsupd, supd };
char *s2f4[] = { Lword, Lmask, MASKBIT14, unsupd, supd };
char *s2f5[] = { Lword, Lmask, MASKBIT15, unsupd, supd };
char *s2f6[] = { Lword, Lmask, MASKBIT0, unsupd, supd };
char *s2f7[] = { Lword, Lmask, MASKBIT1, unsupd, supd };
char *s2f8[] = { Lword, Lmask, MASKBIT2, unsupd, supd };
char *s2f9[] = { Lword, Lmask, MASKBIT3, unsupd, supd };

char **fac1_selects[] = { s1f0, s1f1, s1f2, s1f3, s1f4, s1f5, s1f6,
			s1f7, s1f8, s1f9 };
char **fac2_selects[] = { s2f0, s2f1, s2f2, s2f3,
			s2f4, s2f5, s2f6, s2f7, s2f8, s2f9 };

char *ccitt_options[] = {
"Calling address extension:",
"Called address extension:",
"Min. throughput class negotiation:",
"End-to-end transit delay negotiation:",
"Priority:",
"Protection:",
"Expedited data negotiation:",
"CCITT X.25 version compatibility:",
""
};

char *ccitt0[] = { Lword, Lmask, MASKBIT0, unsupd, supd };
char *ccitt1[] = { Lword, Lmask, MASKBIT1, unsupd, supd };
char *ccitt2[] = { Lword, Lmask, MASKBIT2, unsupd, supd };
char *ccitt3[] = { Lword, Lmask, MASKBIT3, unsupd, supd };
char *ccitt4[] = { Lword, Lmask, MASKBIT4, unsupd, supd };
char *ccitt5[] = { Lword, Lmask, MASKBIT5, unsupd, supd };
char *ccitt6[] = { Lword, Lmask, MASKBIT6, unsupd, supd };
char *ccittc[] = { Lword, Lvalue, "1988", "1984", "1980", "" };

char **ccitt_selects[] = { ccitt0, ccitt1, ccitt2, ccitt3, ccitt4,
			ccitt5, ccitt6, ccittc };

char *time_options[] = {
"T10/T20 - Restart Indication/Request:",
"T11/T21 - Incoming Call/Call Request:",
"T12/T22 - Reset Indication/Request:",
"T13/T23 - Clear Indication/Request:",
"T16/T26 - Interrupt:",
"T28 - Registration Request:",
"R10/R20 - Restart Indication/Request:",
"R12/R22 - Reset Indication/Request:",
"R13/R23 - Clear Indication/Request:",
""
};

char *Stimeop[] = { Lidx, "255", "1" };
char *Sretrop[] = { Lidx, "250", "0" };
char **time_selects[] = { Stimeop, Stimeop, Stimeop, Stimeop, Stimeop,
			Stimeop, Sretrop, Sretrop, Sretrop };


BOOL cardexists[MAX_CARDS];

char *config_fields[] = {
"line_speed",
"T1",
"T2",
"N2",
"max_I_field_length",
"k",
"T4",
"auto_modem_err_fixup",
"auto_HDLC",
"HDLC_config_options",
"DTE",
"packet_window",
"default_packet_size",
"maximum_packet_size",
"lowest_PVC",
"highest_PVC",
"lowest_incomming_channel",
"highest_incomming_channel",
"lowest_two_way_channel",
"highest_two_way_channel",
"lowest_outgoing_channel",
"highest_outgoing_channel",
"X25_config_options",
"X25_response_options",
"genl_facilities_supported_1",
"genl_facilities_supported_2",
"CCITT_facilities_supported",
"non_X25_facilities_supported",
"CCITT_compatibility",
"T10_T20",
"T11_T21",
"T12_T22",
"T13_T23",
"T16_T26",
"T28",
"R10_R20",
"R12_R22",
"R13_R23"
};

// 0=byte dec. val, 1=word dec. val, 2=byte hex val, 3=word hex val.
BYTE byte_or_word[] = {
0, 0, 0, 0, 1, 0, 0, 0, 0, 2, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
3, 2, 3, 3, 3, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0
};

#pragma pack(1)
typedef struct {
	BYTE SDLA_configuration;
	BYTE line_speed_number;
	BYTE T1;
	BYTE T2;
	BYTE N2;
	WORD max_I_field_length;
	BYTE k;
	BYTE T4;
	BYTE auto_modem_err_fixup;
	BYTE auto_HDLC;
	BYTE HDLC_config_options;
	BYTE DTE;
	BYTE packet_window;
	WORD default_packet_size;
	WORD maximum_packet_size;
	WORD lowest_PVC;
	WORD highest_PVC;
	WORD lowest_incomming_channel;
	WORD highest_incomming_channel;
	WORD lowest_two_way_channel;
	WORD highest_two_way_channel;
	WORD lowest_outgoing_channel;
	WORD highest_outgoing_channel;
	WORD X25_config_options;
	BYTE X25_response_options;
	WORD genl_facilities_supported_1;
	WORD genl_facilities_supported_2;
	WORD CCITT_facilities_supported;
	WORD non_X25_facilities_supported;
	WORD CCITT_compatibility;
	BYTE T10_T20;
	BYTE T11_T21;
	BYTE T12_T22;
	BYTE T13_T23;
	BYTE T16_T26;
	BYTE T28;
	BYTE R10_R20;
	BYTE R12_R22;
	BYTE R13_R23;
	UCHAR electrical_interface;
} CONFIG_STRUCT;

// indeces into Sports, Ssegs, Swins
typedef struct {
	BYTE io_port_index, mem_segment_index, mem_window_index;
} HARD_CONFIG;

HARD_CONFIG cfg_hardware;
CONFIG_STRUCT cfg_block;

CONFIG_STRUCT default_cfg = { 0, 2, 3, 0, 10, 1027, 7, 1, 1,
			1, 0x00, 1, 2, 128, 256, 0, 0, 0, 0, 1, 3,
			0, 0, 0x0000, 0x00, 0xffff, 0x000f, 0x007f,
			0x0000, 1988, 15, 15, 15, 15, 15, 15,
			10, 10, 10,
			0 };

// def.hard: io_port=360, mem=d000
HARD_CONFIG default_hard_cfg = { 6, 2, 0 };

/*
void *HDLC_src[] = {&(cfg_block.HDLC_config_options),
			&(cfg_block.line_speed_number),
			&(cfg_block.DTE),
			&(cfg_block.T1),
			&(cfg_block.T2),
			&(cfg_block.T4),
			&(cfg_block.N2),
			&(cfg_block.k),
			&(cfg_block.auto_modem_err_fixup),
			&(cfg_block.auto_HDLC),
			&(cfg_block.HDLC_config_options),
			&(cfg_block.HDLC_config_options)//why twice ????
};
*/
void *HDLC_src[] = {
			&(cfg_block.line_speed_number),
			&(cfg_block.DTE),
			&(cfg_block.T1),
			&(cfg_block.T2),
			&(cfg_block.T4),
			&(cfg_block.N2),
			&(cfg_block.k),
			&(cfg_block.auto_modem_err_fixup),
			&(cfg_block.auto_HDLC),
			&(cfg_block.HDLC_config_options),
			&(cfg_block.HDLC_config_options)
};

void *hardware_src[] = {&(cfg_hardware.io_port_index),
			&(cfg_hardware.mem_segment_index),
			&(cfg_hardware.mem_window_index)
};

void *x25basic_src[] = {&(cfg_block.packet_window),
			&(cfg_block.default_packet_size),
			&(cfg_block.maximum_packet_size),
			&(cfg_block.lowest_PVC),
			&(cfg_block.highest_PVC),
			&(cfg_block.lowest_incomming_channel),
			&(cfg_block.highest_incomming_channel),
			&(cfg_block.lowest_two_way_channel),
			&(cfg_block.highest_two_way_channel),
			&(cfg_block.lowest_outgoing_channel),
			&(cfg_block.highest_outgoing_channel)
};

void *x25config_src[] = {       &(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options),
				&(cfg_block.X25_config_options)
};

void *resp_src[] = {            &(cfg_block.X25_response_options),
				&(cfg_block.X25_response_options),
				&(cfg_block.X25_response_options),
				&(cfg_block.X25_response_options),
				&(cfg_block.X25_response_options)
};

void *fac1_src[] = {            &(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1)
};

void *fac2_src[] = {            &(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_1),
				&(cfg_block.genl_facilities_supported_2),
				&(cfg_block.genl_facilities_supported_2),
				&(cfg_block.genl_facilities_supported_2),
				&(cfg_block.genl_facilities_supported_2)
};

void *ccitt_src[] = {           &(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_facilities_supported),
				&(cfg_block.CCITT_compatibility)
};

void *time_src[] = {            &(cfg_block.T10_T20),
				&(cfg_block.T11_T21),
				&(cfg_block.T12_T22),
				&(cfg_block.T13_T23),
				&(cfg_block.T16_T26),
				&(cfg_block.T28),
				&(cfg_block.R10_R20),
				&(cfg_block.R12_R22),
				&(cfg_block.R13_R23)
};

BYTE num_option_windows = 0;
BOOL refresh = FALSE;
BOOL config_is_modified = FALSE;
BOOL activated_help = FALSE;
DWORD hID = 0;
HMENU hmainmenu = NULL;

typedef struct {
	HWND hwnd;
	char **sel;
	void *defs;
} tagSI;
#pragma pack()

tagSI storeinfo[MAX_OPS];

UINT saveashelpid;
int title_height;

/* prototypes */
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow);

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam );

void AddStringListBox(char far *m);
LRESULT CALLBACK SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
void SelCard(void);
LRESULT CALLBACK DirsDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK CpathDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK ErrorDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK Conf514Dlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);

void ActivateHardware(void);
void ActivateHDLC(void);
void ActivateX25(void);
void ActivateX25Cfg(void);
void ActivateResp(void);
void ActivateFac1(void);
void ActivateFac2(void);
void ActivateCCITT(void);
void ActivateTimes(void);
void SetGroup(char *g);
void SetOptions(char *ops[], char **sels[], void *defind[], int base);
void AddSelectables(HWND cbhwn, char *sels[], void *defitem, int idbase, int opnum);
void Directories(void);
void Cpathname(void);
BOOL LoadConfiguration(void);
BYTE TranslateLookup(UINT par, char *sels[]);
void StoreSelected(HWND cbhwn, char *sels[], void *defitem);
BOOL SaveConfiguration(void);
BOOL PassedChecks(void);
void ReportError(char *error);
BOOL bounds_check(WORD low, WORD hi, char *item1);
BOOL overlap_check(WORD low, WORD hi, char *item1, char *item2);
void MakeNewConfig(void);
BOOL total_channels_check(WORD *start);
LRESULT CALLBACK DopDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
void DriverOps(void);
void WriteTextConfig(void);
void SetMenuCheck(void);

//-------------------------------------
UCHAR DoFindS514Command(HANDLE drv, ALL_514 * frsi);
void InitConfig(void);
void PutConfigFound(void);
void DetectFunction(void);
//-------------------------------------

#ifdef MAKEFORNT
//DWORD GetRegistryDWordValue(char *keyname);
char GetRegistryDWordValue(char *keyname, OUT DWORD* value);

void SetRegistryDWordValue(char *keyname, DWORD value);
BOOL CheckServiceExists(void);
BOOL SetServiceKeys(void);
#endif

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg;
	BOOL fRetVal;
	WNDCLASS wndclass;   // Structure used to register Windows class.
//      int frame_height;
	HMENU hmenu;
	int i;
	DLGPROC ap;
	BOOL went_ok;
	char s[80];
	HDC hdc;
	TEXTMETRIC tm;
	DWORD dw_dummy;

	hdc = GetDC(NULL);
	GetTextMetrics(hdc, &tm);
	ReleaseDC(NULL, hdc);
	ca = tm.tmAveCharWidth;
    title_height = GetSystemMetrics(SM_CYCAPTION);
    if (tm.tmHeight > title_height) title_height = tm.tmHeight;
/*
	title_height=GetSystemMetrics(SM_CYCAPTION);
	ca = CAF;
	if (title_height > 20)
		ca = ((title_height*CAF) / 20);
*/
//      frame_height=GetSystemMetrics(SM_CYFRAME);
	ghinstance = hInstance;
	saveashelpid = RegisterWindowMessage(HELPMSGSTRING);
	card = 0;

	if (hPrevInstance != NULL) return(0);

	wndclass.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wndclass.lpfnWndProc   = MainWndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = ghinstance;
	wndclass.hIcon         = LoadIcon(ghinstance, "confprog");
	wndclass.hCursor       = LoadCursor( NULL, IDC_ARROW );
	wndclass.hbrBackground = (HBRUSH)(COLOR_APPWORKSPACE);//COLOR_WINDOW+1;
	wndclass.lpszMenuName  = "MAINMENU";
	wndclass.lpszClassName = szClassName;

	if (!RegisterClass(&wndclass)) {
		return(0);
	}

	exehwn = CreateWindow( szClassName,
				szTitleName,
				WS_OVERLAPPED | WS_MINIMIZE | WS_MINIMIZEBOX | WS_CAPTION | WS_SYSMENU | WS_BORDER,
				CW_USEDEFAULT,
				200,
				ADJUST(430),
				22*title_height,//20*title_height,
				HWND_DESKTOP,
				NULL,
				ghinstance,
				NULL);

	if (!exehwn)  return(0);

//      cbhwn   = CreateWindow("BUTTON", "Card Select", WS_CHILD | WS_VISIBLE, 2, 2, 100, title_height, exehwn, NULL, ghinstance, NULL);
//      quhwn   = CreateWindow("BUTTON", "Quit", WS_CHILD | WS_VISIBLE, 296, 2, 100, title_height, exehwn, NULL, ghinstance, NULL);
//      hlphwn = CreateWindow("BUTTON", "Help", WS_CHILD | WS_VISIBLE, 32, 300, 80, title_height, exehwn, (HMENU)199, ghinstance, NULL);
//      lbhwn = CreateWindow("LISTBOX", "", WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_DISABLENOSCROLL, 1, title_height+5, 396,
//                               title_height*6, exehwn, NULL, ghinstance, NULL);

	ShowWindow(exehwn, cmdShow);
	UpdateWindow(exehwn);

	hmainmenu = GetMenu(exehwn);
/*
	hmenu = GetSystemMenu(exehwn, FALSE);
	AppendMenu(hmenu, MF_SEPARATOR, 0, (LPSTR) NULL);
	AppendMenu(hmenu, MF_STRING, IDM_ABOUT, "About...");
*/

//      CheckCardStatus();
	for (i=0; i < MAX_OPS; i++)
		sel_hwn[i] = ops_hwn[i] = storeinfo[i].hwnd = NULL;

#ifdef MAKEFORNT
	// first check if the SDLA service is in the registry;
	// if not, create the appropriate keys and values
	if (!CheckServiceExists()) {
		if (SetServiceKeys())
			MessageBox(exehwn, "The registry has been updated to include the SDLA device driver.  Restart the system after configuring your card(s) for these changes to take effect.", "SDLA Service Registered", MB_OK | MB_ICONINFORMATION);
		else
			MessageBox(exehwn, "A fatal error occurred while attempting to create the required keys in the registry for the SDLA service.", "Fatal Error (Registry)", MB_OK | MB_ICONSTOP);
	}
#endif

	// see which card entries exist
	for (card=0; card < MAX_CARDS; card++)
	{
#ifdef MAKEFORNT
		//if (GetRegistryDWordValue(iniWSEntry))
		if (!GetRegistryDWordValue(iniSlotEntry, &dw_dummy))
			cardexists[card] = TRUE;
		else
			cardexists[card] = FALSE;
#else
		sprintf(s, "%s%d", iniCardSectionBase, card);
		if (GetPrivateProfileInt(s, iniWSEntry, 0, our_ini_file)) cardexists[card] = TRUE;
		else cardexists[card] = FALSE;
#endif
	}
	card=0;
// ***** MAJOR THINGS NEED TO BE DONE TO ACCOMODATE LACK OF CONFIG INFO
	sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
	SAYNOSTATE();

	if (cardexists[card])
	{
		if (!LoadConfiguration()) {
			if (MessageBox(exehwn, "A fatal loading error occurred.  Reset the configuration to default values?", "Configuration Load Error", MB_YESNO | MB_ICONSTOP) == IDYES)
				MakeNewConfig();
			else  MessageBox(exehwn, "You are advised to check the configuration file pathname in the Configuration menu.", "Fatal Error", MB_OK | MB_ICONINFORMATION);
		}
	} else {
		MakeNewConfig();
		MessageBox(exehwn, "A new configuration entry was created for the default card 0", "New Configuration", MB_OK | MB_ICONINFORMATION);
	}

	fRetVal = TRUE;
	while (fRetVal)  {
		GetMessage(&msg, NULL, 0, 0);
		if (msg.message == WM_QUIT)
			fRetVal = FALSE;	/* leave main loop */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return fRetVal;


//      return(msg.wParam);
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam )
{
//      MSG msg;
	HWND h;
//      static unsigned long poll_count = 0;
	char s[80];
	int i;
	DLGPROC dproc;

	switch(iMessage) {
	case WM_CREATE:
//              XAPIAlive();
//              XAPISetup();
		return(0);
	case WM_DESTROY:
//              XAPICleanup();
		PostQuitMessage(0);
		break;
	case WM_INITMENU:
		SetMenuCheck();
		break;
	case WM_CLOSE:
		if (config_is_modified) {
			switch(MessageBox(exehwn, "Changes have been made to this card's configuration.  Save these changes before quitting?",
				"Quit XCONFIG", MB_YESNOCANCEL | MB_ICONQUESTION)) {
			case IDYES:
				if (!SaveConfiguration()) return(0);
				break;
			case IDCANCEL: return(0);
			}
		}
		if (activated_help) WinHelp(exehwn, helpname, HELP_QUIT, 0L);
		DestroyWindow(hWnd);
		return(0);

	case MSG_CLOSEERROR:
		DestroyWindow(errorhwn);
		errorhwn = NULL;
		FreeProcInstance((FARPROC)errorproc);
		break;
	case WM_PARENTNOTIFY:
		if (GET_WM_PARENTNOTIFY_HWNDCHILD(wParam, lParam) == errorhwn
			&& GET_WM_PARENTNOTIFY_MSG(wParam, lParam) == WM_DESTROY) {
			errorhwn = NULL;
			FreeProcInstance((FARPROC)errorproc);
		}
		break;

	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 101:
			SelCard();
			break;
		case 103:
			ActivateHardware();
			break;
		case 10:
			Directories();
			break;
		case 104:
			ActivateHDLC();
			break;
		case 105:
			ActivateX25();
			break;
		case 106:
			ActivateX25Cfg();
			break;
		case 107:
			ActivateResp();
			break;
		case 108:
			ActivateFac1();
			break;
		case 109:
			ActivateFac2();
			break;
		case 110:
			ActivateCCITT();
			break;
		case 111:
			ActivateTimes();
			break;
		case 1:
			Cpathname();
			break;
		case 2:
			PostMessage(exehwn, WM_CLOSE, 0, 0L);
			break;
		case 3:
//			OutputDebugString("calling SaveConfiguration()\n");
			SaveConfiguration();
			break;
		case 4:
//			OutputDebugString("CM_CONFIGURECHECK_CONFIGURATION\n");
			if (PassedChecks())
			{
//				OutputDebugString("calling ReportError : All configuration entries are valid.\n");
				ReportError("All configuration entries are valid.");
			}
			break;
		case 5:
			DriverOps();
			break;
		case 6:
			WriteTextConfig();
			break;
		case 199:
			WinHelp(exehwn, helpname, HELP_CONTEXT, hID);
			activated_help = TRUE;
			break;
		case 190:
			MessageBox(exehwn, aboutstatement, abouttitle, MB_OK | MB_ICONINFORMATION);
			break;
		default:
			h = GET_WM_COMMAND_HWND(wParam, lParam);
			for (i=0; i < num_option_windows; i++)
				if (storeinfo[i].hwnd == h) {
					if (GET_WM_COMMAND_CMD(wParam, lParam) == CBN_SELENDOK ||
					GET_WM_COMMAND_CMD(wParam, lParam) == EN_CHANGE)
						StoreSelected(h, storeinfo[i].sel, storeinfo[i].defs);
				}
			break;

		}
		return(0);
	case WM_SYSCOMMAND:
		if ((wParam & 0xfff0) == SC_CLOSE) {
			PostMessage(exehwn, WM_CLOSE, 0, 0L);
			return(0);
		}
		return DefWindowProc( hWnd, iMessage, wParam, lParam );
	default:
		if (iMessage == saveashelpid) {
			WinHelp(exehwn, helpname, HELP_CONTEXT, 99);
			activated_help = TRUE;
			return(0);
		} else
			return DefWindowProc( hWnd, iMessage, wParam, lParam );
	}
	return(1);
}

void SetMenuCheck(void)
{
	int i;
	for (i=0; i < 9; i++)
		CheckMenuItem(hmainmenu, 103+i, (hID == (i+1)) ? MF_CHECKED : MF_UNCHECKED);
}

BOOL LoadConfiguration(void)
{
	char sc[40], s[80];
	int handle;
	DWORD p;

	sprintf(sc, "%s%u", iniCardSectionBase, card);
	GetPrivateProfileString(sc, iniConfigEntry, "", s, 79, our_ini_file);
	if (s[0] == '\0') {
		MessageBox(exehwn, "No pathname exists in SDLA.INI for the configuration file!", "FILE OPEN ERROR", MB_OK | MB_ICONEXCLAMATION);
		return(FALSE);
	}
	handle = open(s, O_BINARY | O_RDONLY);
	if (handle == -1) {
		MessageBox(exehwn, s, "FILE OPEN ERROR", MB_OK | MB_ICONEXCLAMATION);
		return(FALSE);
	}
	read(handle, (void *)&(cfg_block.SDLA_configuration), sizeof(CONFIG_STRUCT));
	close(handle);

#ifdef MAKEFORNT
	GetRegistryDWordValue(iniPortEntry, &p);
#else
	p = GetPrivateProfileInt(sc, iniPortEntry, 0x360, our_ini_file);
#endif
	cfg_hardware.io_port_index = TranslateLookup(p, Sports);

#ifdef MAKEFORNT
	GetRegistryDWordValue(iniWSEntry, &p);
#else
	p = GetPrivateProfileInt(sc, iniWSEntry, 0xd000, our_ini_file);
#endif
	cfg_hardware.mem_segment_index = TranslateLookup(p, Ssegs);

#ifdef MAKEFORNT
	GetRegistryDWordValue(iniWOEntry, &p);
#else
	p = GetPrivateProfileInt(sc, iniWOEntry, 0x0000, our_ini_file);
#endif
	cfg_hardware.mem_window_index = TranslateLookup(p, Swins);

	config_is_modified = FALSE;

	//ActivateHardware();
	ActivateHDLC();

	return(TRUE);
}

BYTE TranslateLookup(UINT par, char *sels[])
{
	BYTE i;
	UINT n;

	i=0;
	while (sels[i][0] != NULL) {
		sscanf(sels[i], "%X", &n);
		if (n == par) return(i);
		i++;
	}
	return(0);
}

BOOL SaveConfiguration(void)
{
	char sc[40], s[80];
	int handle;
	UINT p;

	if (!PassedChecks())
	{
//		OutputDebugString("!PassedChecks()\n");
		return(FALSE);
	}

	sprintf(sc, "%s%u", iniCardSectionBase, card);
	GetPrivateProfileString(sc, iniConfigEntry, "", s, 79, our_ini_file);
	handle = open(s, O_BINARY | O_CREAT | O_TRUNC | O_WRONLY, S_IREAD | S_IWRITE);
	if (handle == -1) {
		MessageBox(exehwn, s, "FILE CREATE/WRITE ERROR", MB_OK | MB_ICONEXCLAMATION);
		return(FALSE);
	}

	cfg_block.max_I_field_length = 1027;
	cfg_block.SDLA_configuration = 0;       // always set at load time

	write(handle, (void *)&(cfg_block.SDLA_configuration), sizeof(CONFIG_STRUCT));
	close(handle);

#ifdef MAKEFORNT
	//sscanf(Sports[cfg_hardware.io_port_index], "%X", &p);
//	SetRegistryDWordValue(iniPortEntry, p);
	//sscanf(Ssegs[cfg_hardware.mem_segment_index], "%X", &p);
//	SetRegistryDWordValue(iniWSEntry, p);
	//sscanf(Swins[cfg_hardware.mem_window_index], "%X", &p);
//	SetRegistryDWordValue(iniWOEntry, p);

	// rigged at 8k window
//	SetRegistryDWordValue(iniSizeEntry, 0x2000);
	MessageBox(exehwn, 
		"If the card location or onboard CPU used has been changed, restart the SDLA service by rebooting,\nor typing: NET STOP SDLA followed by NET START SDLA at the DOS prompt.",
		"Restart SDLA Service", MB_ICONINFORMATION | MB_OK);
#else
	WritePrivateProfileString(sc, iniPortEntry, Sports[cfg_hardware.io_port_index], our_ini_file);
	WritePrivateProfileString(sc, iniWSEntry, Ssegs[cfg_hardware.mem_segment_index], our_ini_file);
	WritePrivateProfileString(sc, iniWOEntry, Swins[cfg_hardware.mem_window_index], our_ini_file);
	// rigged at 8k window
	WritePrivateProfileString(sc, iniSizeEntry, "0x2000", our_ini_file);
#endif

	config_is_modified = FALSE;

	return(TRUE);
}


void ActivateHardware(void)
{
//-----------------------------------------
	conf514proc = (DLGPROC)MakeProcInstance((FARPROC)Conf514Dlg, ghinstance);
	exehwn514 = CreateDialog(ghinstance, "MAINWIN", exehwn, conf514proc);
	if (!exehwn514)
	{
//		OutputDebugString( "!exehwn\n");					
		return;
	}
	DetectFunction();
	PutConfigFound();
	InitConfig();
//-----------------------------------------
//	ActivateHDLC();
//	SetGroup("SDLA Hardware Options");
//	SetOptions(hard_options, hard_selects, hardware_src, 200);
//	hID = 1;
}


void DetectFunction(void)
{
	char *sDriverName = "Conf514";
	char *sDriverFile = "Conf514";
    int rc = 0;

	HANDLE drv;

    LoadDriver *loadDriver = NewLoadDriver ();

    if (!loadDriver)
    {
//        OutputDebugString("This program can run only on Win95/Win98/WinNT\n");
		MessageBox(exehwn, "This program can run only on Win95/Win98/WinNT\n.", "Fatal Error", MB_OK | MB_ICONSTOP);
        delete loadDriver;
    }
    if (loadDriver->HasErr())
    {
//        OutputDebugString("loadDriver->HasErr()\n");
		delete loadDriver;
    }

    loadDriver->Init(sDriverName, sDriverFile);
	loadDriver->Create();
	loadDriver->Start();

	// Open device number 0
	drv = CreateFile("\\\\.\\CONF514", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, (LPSECURITY_ATTRIBUTES)NULL,
			OPEN_EXISTING, FILE_FLAG_NO_BUFFERING | FILE_FLAG_WRITE_THROUGH, (HANDLE)NULL);
    if (drv == INVALID_HANDLE_VALUE)
	{
		MessageBox(exehwn, "Conf514.sys can't start, corrupted or unavailable.", "Fatal Error", MB_OK | MB_ICONSTOP);
	}

	DoFindS514Command(drv, &statinfo);

	// close the open handle
	CloseHandle(drv);
	loadDriver->Stop();
	loadDriver->Delete();

}

// find s514 boards
UCHAR DoFindS514Command(HANDLE drv, ALL_514 * frsi)
{
	DWORD ln;

	if (DeviceIoControl(
		drv,
		IoctlFindS514Command,
		NULL,
		0,
		(LPVOID)frsi,
		sizeof(ALL_514),
		(LPDWORD)(&ln),
		(LPOVERLAPPED)NULL
		) == FALSE) return(0);	// STATUS_UNSUCCESSFUL
		
	return(1);
}


LRESULT CALLBACK Conf514Dlg(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam )
{
	UINT i, HWType = 514;
	DWORD d;
	BYTE card;
	char s[80];
	DLGPROC dproc;
	int NumOfCardsConfigured =0, bus=0, slot=0, DecimalCPU =0, index, ind;
	char CPU;
	HKEY hkey;

	switch(iMessage)
	{
	case WM_INITDIALOG:
//		OutputDebugString( "Conf514Dlg :WM_INITDIALOG\n" );	
		return(1);
	case WM_CLOSE:
//		OutputDebugString( "Conf514Dlg :WM_CLOSE\n" );					
		DestroyWindow(exehwn514);//hWnd);
//		PostQuitMessage(0);
		return(0);

	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam))
		{
		case 100:
//			OutputDebugString( "Conf514Dlg :100\n" );					
//			if (changemade)
//				MessageBox(exehwn, "Restart service or reboot for changes to take effect.\nThe service may be restarted at the command prompt by typing\nNET STOP SANGSTRM followed by NET START SANGSTRM.", "Configuration Changes Made", MB_OK | MB_ICONINFORMATION);
			PostMessage(hWnd, WM_CLOSE, 0, 0L);
			break;
		case 120:
//			OutputDebugString( "Conf514Dlg :120\n" );
//			changemade = 1;
			lastsel = (WPARAM)SendDlgItemMessage(exehwn514, 200, LB_GETCURSEL, 0, 0L);
//			sprintf(DebugString, "lastsel =%d\n",lastsel);
//			OutputDebugString(DebugString);
						
			SendDlgItemMessage(exehwn514, 200, LB_GETTEXT , lastsel, (LPARAM)s);

			bus = atoi((const char *)&s[2]);
	
			slot = atoi((const char *)&s[17]);

			CPU = s[33];
			if(CPU == 'B')
				DecimalCPU = 1;

//			for(ind=0; ind<50;ind++)
//			{
//				sprintf(DebugString, "s[%d]=%C ",ind, s[ind]);
//				OutputDebugString(DebugString);
//			}
//			OutputDebugString("\n\n");

//			sprintf(DebugString, "OnSet Reading:bus=%d slot=%d CPU = %C\n", bus, slot, CPU);
//			OutputDebugString(DebugString);
			
			SetRegistryDWordValue("BusNumber", bus);
			SetRegistryDWordValue("SlotNumber", slot);
			SetRegistryDWordValue("CPU", DecimalCPU);
			SetRegistryDWordValue("HardWareType", HWType);
			InitConfig();
			
			break;
		}
		break;
	case WM_SYSCOMMAND:
		if (wParam == SC_CLOSE)
		{
//			OutputDebugString( "wParam == SC_CLOSE\n" );					
//			DestroyWindow(hWnd);
//			PostQuitMessage(0);
			return(1);//don't let close this way
		}
		if (GET_WM_COMMAND_ID(wParam, lParam) == IDM_ABOUT)
		{
			MessageBox(hWnd, aboutstatement, abouttitle, MB_OK | MB_ICONINFORMATION);
			return(0);
		}
		break;
	}
	return(0);
}

void PutConfigFound()
{
	BYTE card;
	char s[80], s1[80];
	DWORD BusNumber, SlotNumber;
	char CPUA = 'A', CPUB = 'B';

	SendDlgItemMessage(exehwn514, 200, LB_RESETCONTENT, 0, 0L);

	for(card=0;card<statinfo.NumOfBoardsFound;card++)
	{
		sprintf(s, " ");

		if (statinfo.card[card].DoubleCPU == 1)
		{
			BusNumber = statinfo.card[card].BusNumber;
			SlotNumber = statinfo.card[card].SlotNumber;
			sprintf(s1, "%2u              %2u              %C", BusNumber, SlotNumber, CPUA);
			strcat(s, s1);
			sprintf(DebugString, s);
			SendDlgItemMessage(exehwn514, 200, LB_ADDSTRING, 0, (LPARAM)s);
			//lbxPorts->AddString(s);

			sprintf(s, " ");
			sprintf(s1, "%2u              %2u              %C", BusNumber, SlotNumber, CPUB);
			strcat(s, s1);
			SendDlgItemMessage(exehwn514, 200, LB_ADDSTRING, 0, (LPARAM)s);
			//lbxPorts->AddString(s);
		}
		else
		{
			BusNumber = statinfo.card[card].BusNumber;
			SlotNumber = statinfo.card[card].SlotNumber;
			sprintf(s1, "%2u              %2u              %C", BusNumber, SlotNumber, CPUA);
			strcat(s, s1);
			SendDlgItemMessage(exehwn514, 200, LB_ADDSTRING, 0, (LPARAM)s);
			//lbxPorts->AddString(s);
		}
	}
	SendDlgItemMessage( exehwn514, 200, LB_SETCURSEL, 0, 0 );					
	//lbxPorts->SetCurSel( 0);
}


void InitConfig()
{
	char s[80];
	DWORD BusNumber =0, SlotNumber =0, CPU;
	char CharCPU = 'A';
	
//	OutputDebugString("\nInitConfig :GetRegistryValues\n");

	if(!GetRegistryDWordValue(iniBusEntry, &BusNumber) &&
	   !GetRegistryDWordValue(iniSlotEntry, &SlotNumber))
	//if(SlotNumber)
	{	
        GetRegistryDWordValue(iniCPUEntry, &CPU);

		if(CPU == 1){
			CharCPU = 'B';
		}else{
			CharCPU = 'A';
		}
		sprintf(DebugString, "InitConfig: BusNumber = %d SlotNumber = %d CPU=%d\n", BusNumber, SlotNumber, CPU);
//		OutputDebugString(DebugString);

	
		sprintf(s, "%2u               %2u               %C", BusNumber, SlotNumber, CharCPU);

		SendDlgItemMessage(exehwn514, 201, LB_RESETCONTENT, 0, 0L);

		SendDlgItemMessage(exehwn514, 201, LB_ADDSTRING, 0, (LPARAM)s);
	}
	else
		SendDlgItemMessage(exehwn514, 201, LB_RESETCONTENT, 0, 0L);
}


void ActivateHDLC(void)
{
	SetGroup("HDLC Options");
	SetOptions(HDLC_options, HDLC_selects, HDLC_src, 250);
	hID = 2;
}

void ActivateX25(void)
{
	SetGroup("X.25 Packet and Logical Channel Configuration");
	SetOptions(x25basic_options, x25basic_selects, x25basic_src, 300);
	hID = 3;
}

void ActivateX25Cfg(void)
{
	SetGroup("X.25 Configuration Options");
	SetOptions(x25config_options, x25config_selects, x25config_src, 350);
	hID = 4;
}

void ActivateResp(void)
{
	SetGroup("X.25 Response Options");
	SetOptions(resp_options, resp_selects, resp_src, 400);
	hID = 5;
}

void ActivateFac1(void)
{
	SetGroup("X.25 General Facilities Page 1");
	SetOptions(fac1_options, fac1_selects, fac1_src, 450);
	hID = 6;
}

void ActivateFac2(void)
{
	SetGroup("X.25 General Facilities Page 2");
	SetOptions(fac2_options, fac2_selects, fac2_src, 500);
	hID = 7;
}

void ActivateCCITT(void)
{
	SetGroup("CCITT Facilities and Compatibility");
	SetOptions(ccitt_options, ccitt_selects, ccitt_src, 550);
	hID = 8;
}

void ActivateTimes(void)
{
	SetGroup("Timeout Values and Retransmission Counts");
	SetOptions(time_options, time_selects, time_src, 600);
	hID = 9;
}

void SetGroup(char *g)
{
	if (grp_hwn != NULL)
		SetWindowText(grp_hwn, g);
	else 
	{
		grp_hwn = CreateWindow("BUTTON", g, WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
			(6-3), 6, ADJUST(418), (19*title_height+(title_height/2) - 5), exehwn, NULL, ghinstance, NULL);
//		grp_hwn = CreateWindow("BUTTON", g, WS_CHILD | WS_VISIBLE | BS_GROUPBOX,
//			(6-3), 6, ADJUST(618), (17*title_height+(title_height/2) - 5), exehwn, NULL, ghinstance, NULL);
	}
}

//	SetOptions(HDLC_options, HDLC_selects, HDLC_src, 300);//250);
void SetOptions(char *ops[], char **sels[], void *defind[], int base)
{
	BYTE i, j;

	if (refresh)
	{
		for (i=0; i < num_option_windows; i++) {
			DestroyWindow(ops_hwn[i]); ops_hwn[i] = NULL;
			DestroyWindow(sel_hwn[i]); sel_hwn[i] = NULL;
		}
		num_option_windows = 0;
		refresh = FALSE;
	}
	i=0;
	while (ops[i][0] != NULL)
	{
		if (ops_hwn[i] != NULL) 
		{
			SetWindowText(ops_hwn[i], ops[i]);
			if (i >= num_option_windows) {
				ShowWindow(ops_hwn[i], SW_SHOW);
				ShowWindow(sel_hwn[i], SW_SHOW);
			}
		}
		else
		{
			ops_hwn[i] = CreateWindow("STATIC", ops[i], WS_CHILD | WS_VISIBLE | SS_RIGHT,
					12, TOP_OP_LINE+3+(i*(title_height+8)), ADJUST(250), 22, exehwn, (HMENU)-1, ghinstance, NULL);
			sel_hwn[i] = CreateWindow("COMBOBOX", "", WS_CHILD | CBS_HASSTRINGS | CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP,
					ADJUST(250)+20, TOP_OP_LINE+(i*(title_height+8)), ADJUST(120), 100,
					exehwn, (HMENU)(base+i), ghinstance, NULL);
		}
		AddSelectables(sel_hwn[i], sels[i], defind[i], base, i);
		if (!IsWindowVisible(sel_hwn[i]))  ShowWindow(sel_hwn[i], SW_SHOWNORMAL);

		storeinfo[i].hwnd = sel_hwn[i];
		storeinfo[i].sel = sels[i];
		storeinfo[i].defs = defind[i];

		i++;
	}
	if (num_option_windows > i) {
		for (j=i; j < num_option_windows; j++) {
			ShowWindow(ops_hwn[j], SW_HIDE);
			ShowWindow(sel_hwn[j], SW_HIDE);
		}
	}
	num_option_windows = i;
}

void AddSelectables(HWND cbhwn, char *sels[], void *defitem, int idbase, int opnum)
{
	int i, low, upp, j, def;
	char s[10];
	WORD mask;
	BYTE *bptr, base;
	WORD *wptr;

	i=0; base=0;
	SendMessage(cbhwn, CB_RESETCONTENT, 0, 0L);
	if (sels[i][0] == '+') {
		base++;
		wptr = (WORD *)defitem;
		bptr = NULL;
	} else {
		wptr = NULL;
		bptr = (BYTE *)defitem;
	}
	if (sels[i+base][0] == '#') {
		mask = (WORD)atoi(sels[1+base]);
		SendMessage(cbhwn, CB_ADDSTRING, 0, (LPARAM)sels[2+base]);
		SendMessage(cbhwn, CB_ADDSTRING, 0, (LPARAM)sels[3+base]);
		SendMessage(cbhwn, CB_SETCURSEL, ((bptr == NULL) ? (*wptr & mask) : (*bptr & mask)) ? 1 : 0, 0L);
	}
	else if (sels[i+base][0] == '$') {
		i++; j=0; def=0;
		while (sels[i+base][0] != NULL) {
			SendMessage(cbhwn, CB_ADDSTRING, 0, (LPARAM)sels[i+base]);
			if (atoi(sels[i+base]) == ((bptr == NULL) ? *wptr : *bptr))
				def = j;
			j++;
			i++;
		}
		SendMessage(cbhwn, CB_SETCURSEL, def, 0L);
	}
	else if (sels[i+base][0] == '&') {
		DestroyWindow(sel_hwn[opnum]);
		sprintf(s, "%u", (bptr == NULL) ? *wptr : *bptr);
		sel_hwn[opnum] = CreateWindow("EDIT", s, WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_BORDER,
				ADJUST(250)+20, TOP_OP_LINE+(opnum*(title_height+8)), ADJUST(120), title_height+2,
				exehwn, (HMENU)(idbase+opnum), ghinstance, NULL);
		refresh = TRUE;
	}
	else if (sels[i+base][0] == '!') {
		upp = atoi(sels[1+base]);
		low = atoi(sels[2+base]);
		for (i=low; i <= upp; i++) {
			sprintf(s, "%d", i);
			SendMessage(cbhwn, CB_ADDSTRING, 0, (LPARAM)s);
		}
		SendMessage(cbhwn, CB_SETCURSEL, ((bptr == NULL) ? (*wptr-low) : (*bptr-low)), 0L);
	} else {
		while (sels[i+base][0] != NULL) {
			SendMessage(cbhwn, CB_ADDSTRING, 0, (LPARAM)sels[i+base]);
			i++;
		}
		SendMessage(cbhwn, CB_SETCURSEL, (bptr == NULL) ? (*wptr) : (*bptr), 0L);
	}
}

void StoreSelected(HWND cbhwn, char *sels[], void *defitem)
{
	int i, low, upp, j, def;
	char s[30];
	WORD mask;
	BYTE *bptr, base, orig_byte;
	WORD *wptr, orig_word;

	i=0; base=0;
	if (sels[i][0] == '+') {
		base++;
		wptr = (WORD *)defitem;
		bptr = NULL;
		orig_word = *wptr;
	} else {
		wptr = NULL;
		bptr = (BYTE *)defitem;
		orig_byte = *bptr;
	}
	if (sels[i+base][0] == '#') {
		mask = (WORD)atoi(sels[1+base]);
		if (SendMessage(cbhwn, CB_GETCURSEL, 0, 0L)) {
			if (bptr == NULL) *wptr |= mask;
			else *bptr |= (BYTE)mask;
		} else {
			if (bptr == NULL) *wptr &= (mask ^ 0xffff);
			else *bptr &= (((BYTE)mask) ^ 0xff);
		}
	}
	else if (sels[i+base][0] == '$') {
		SendMessage(cbhwn, CB_GETLBTEXT, (WPARAM)SendMessage(cbhwn, CB_GETCURSEL, 0, 0L), (LPARAM)s);
		i = atoi(s);
		if (bptr == NULL) *wptr = (WORD)i;
		else *bptr = (BYTE)i;
	}
	else if (sels[i+base][0] == '&') {
		SendMessage(cbhwn, WM_GETTEXT, 29, (LPARAM)s);
		i = atoi(s);
		if (bptr == NULL) *wptr = (WORD)i;
		else *bptr = (BYTE)i;
	}
	else if (sels[i+base][0] == '!') {
		upp = atoi(sels[1+base]);
		low = atoi(sels[2+base]);
		i = (int)SendMessage(cbhwn, CB_GETCURSEL, 0, 0L);
		if (bptr == NULL) *wptr = (WORD)i+(WORD)low;
		else *bptr = (BYTE)i+(BYTE)low;
	} else {
		i = (int)SendMessage(cbhwn, CB_GETCURSEL, 0, 0L);
		if (bptr == NULL) *wptr = (WORD)i;
		else *bptr = (BYTE)i;
	}

	// throw in a check to see if config structure changed
	if (bptr == NULL) {
		if (*wptr != orig_word) config_is_modified = TRUE;
	}
	else if (*bptr != orig_byte) config_is_modified = TRUE;

}

void SelCard(void)
{
	DLGPROC dproc;
	int i;
//      char s[80];

	if (config_is_modified) {
		if (MessageBox(exehwn, "Changes that have been made to the current card's configuration will be lost if you proceed.  Are you sure you want to load another configuration?",
			"Select Card and Load Configuration", MB_YESNO | MB_ICONQUESTION)
			== IDNO) return;
	}

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
	if (i)
	{
		if (!cardexists[i-1])
		{
			// new card entry
			if (MessageBox(exehwn, "The specified logical card number has not been configured yet.  Create a new configuration entry for it?", "New Card Number", MB_YESNO | MB_ICONQUESTION) == IDYES) {
				card = i-1;
				MakeNewConfig();
			}
		}
		else
		{
			card = i-1;
			if (!LoadConfiguration())
				MessageBox(exehwn, "The configuration file pathname should be changed to reflect the new location of the configuration file for this card number.  Otherwise, the current configuration in memory may be edited and saved for use with this card number.", "Configuration Load Error", MB_OK | MB_ICONEXCLAMATION);
		}
		sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
		SAYNOSTATE();
//              CheckCardStatus();
	}
}

void MakeNewConfig(void)
{
	char sc[40], s[81];
	int i;

	memcpy((void *)&(cfg_block.SDLA_configuration), (void *)&(default_cfg.SDLA_configuration), sizeof(CONFIG_STRUCT));
	memcpy((void *)&(cfg_hardware.io_port_index), (void *)&(default_hard_cfg.io_port_index), sizeof(HARD_CONFIG));
	GetPrivateProfileString(iniConfigSection, iniDefEntry, "", s, 67, our_ini_file);
	for (i=strlen(s)-1; i >= 0; i--) {
		if (s[i] == ' ') continue;
		if (s[i] == '\\') { s[i] = '\0'; break; }
		break;
	}
	if (i < 1) {
		strcpy(s, ".");
		MessageBox(exehwn, "Warning: The configuration file pathname is not fully qualified due to the default directory setting being non-defined (see File | Directories...). Check this pathname before running the loader.", "Pathname Not Reliable", MB_OK | MB_ICONSTOP);
	}
	else s[i+1] = '\0';
	sprintf(sc, "\\sdla_cfg.%u", card);
	strcat(s, sc);
	sprintf(sc, "%s%u", iniCardSectionBase, card);
	WritePrivateProfileString(sc, iniConfigEntry, s, our_ini_file);

	SaveConfiguration();

	//ActivateHardware();
	ActivateHDLC();
	cardexists[card] = TRUE;
}

void Directories(void)
{
	DLGPROC dproc;
	int i;
//      char s[80];

	dproc = (DLGPROC)MakeProcInstance((FARPROC)DirsDlg, ghinstance);
	i=DialogBox(ghinstance, "DIRS", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
}

void Cpathname(void)
{
	DLGPROC dproc;
	int i;
//      char s[80];

	dproc = (DLGPROC)MakeProcInstance((FARPROC)CpathDlg, ghinstance);
	i=DialogBox(ghinstance, "CPATH", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
}

LRESULT CALLBACK SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	int n, m, default_card;
	LRESULT c;
	char s[5];
	static int ncard;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:  /* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		ncard = (int)card;
		for (n=0; n < 16; n++) {
			sprintf(s, "%2d", n);
			SendDlgItemMessage(hDlg, 101, CB_ADDSTRING, 0, (LPARAM)s);
			if (ncard == n)
				SendDlgItemMessage(hDlg, 101, CB_SETCURSEL, n, 0);
		}
//              default_card = GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
		default_card = 0;
		sprintf(s, "%u", (UINT)default_card);
		SetDlgItemText(hDlg, 103, s);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 101:
			if (GET_WM_COMMAND_CMD(wParam, lParam) == CBN_SELENDOK) {
				SendDlgItemMessage(hDlg, 101, CB_GETLBTEXT, (WPARAM)SendDlgItemMessage(hDlg, 101, CB_GETCURSEL, 0, 0), (LPARAM)s);
				ncard = atoi(s);
			}
			break;
		case IDOK:
			if (IsDlgButtonChecked(hDlg, 102)) {
				sprintf(s, "%u", (UINT)ncard);
				//WritePrivateProfileString(iniHardwareSection, iniCardEntry, s, our_ini_file);
			}
			sprintf(DebugString, "SelCardDlg IDOK:ncard=%d\n", ncard);
//			OutputDebugString(DebugString);

			EndDialog(hDlg, ncard+1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

LRESULT CALLBACK DirsDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	char s[80];
	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:  /* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		GetPrivateProfileString(iniConfigSection, iniDefEntry, "", s, 79, our_ini_file);
		SetDlgItemText(hDlg, 101, s);
		GetPrivateProfileString(iniLoaderSection, ini502TestEntry, "", s, 79, our_ini_file);
		SetDlgItemText(hDlg, 102, s);
		GetPrivateProfileString(iniLoaderSection, ini502CodeEntry, "", s, 79, our_ini_file);
		SetDlgItemText(hDlg, 103, s);
		SendDlgItemMessage(hDlg, 101, EM_LIMITTEXT, 79, 0L);
		SendDlgItemMessage(hDlg, 102, EM_LIMITTEXT, 79, 0L);
		SendDlgItemMessage(hDlg, 103, EM_LIMITTEXT, 79, 0L);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 1:
			GetDlgItemText(hDlg, 101, s, 79);
			WritePrivateProfileString(iniConfigSection, iniDefEntry, s, our_ini_file);
			GetDlgItemText(hDlg, 102, s, 79);
			WritePrivateProfileString(iniLoaderSection, ini502TestEntry, s, our_ini_file);
			GetDlgItemText(hDlg, 103, s, 79);
			WritePrivateProfileString(iniLoaderSection, ini502CodeEntry, s, our_ini_file);
			EndDialog(hDlg, 0);
			break;
		case 2:
			EndDialog(hDlg, 0);
			break;
		case 3:
			WinHelp(exehwn, helpname, HELP_CONTEXT, 11L);
			activated_help = TRUE;
			break;

		}
	}
	return(0);
}

LRESULT CALLBACK CpathDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	char s[80], sc[40];
	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:  /* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		sprintf(s, "Card %u pathname:", card);
		SetDlgItemText(hDlg, 110, s);
		sprintf(sc, "%s%u", iniCardSectionBase, card);
		GetPrivateProfileString(sc, iniConfigEntry, "", s, 79, our_ini_file);
		SetDlgItemText(hDlg, 101, s);
		SendDlgItemMessage(hDlg, 101, EM_LIMITTEXT, 79, 0L);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 1:
			GetDlgItemText(hDlg, 101, s, 79);
			sprintf(sc, "%s%u", iniCardSectionBase, card);
			WritePrivateProfileString(sc, iniConfigEntry, s, our_ini_file);
			EndDialog(hDlg, 1);
			break;
		case 2:
			EndDialog(hDlg, 0);
			break;
		case 3:
			WinHelp(exehwn, helpname, HELP_CONTEXT, 10L);
			activated_help = TRUE;
			break;
		}
	}
	return(0);
}


LRESULT CALLBACK ErrorDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
//      int i;
	switch(iMessage) 
	{
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, 101, LB_SETHORIZONTALEXTENT, 700, 0L);
//              i=SendMessage(hDlg, LB_GETHORIZONTALEXTENT, 0, 0L);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam))
		{
		case IDOK:
			SendMessage(exehwn, MSG_CLOSEERROR, 0, 0L);
			break;
		case 3:
			WinHelp(exehwn, helpname, HELP_CONTEXT, 12L);
			activated_help = TRUE;
			break;
		}
	}
	return(0);
}

BOOL PassedChecks(void)
{
	BOOL rcode;

	rcode = TRUE;
	ReportError(NULL);      // reset window content

	if (cfg_block.T2 >= cfg_block.T1) {
		ReportError("Error: T2 must always be less than T1");
//		OutputDebugString("Error: T2 must always be less than T1\n");
		rcode = FALSE;
	}
	if (cfg_block.maximum_packet_size < cfg_block.default_packet_size) {
//		OutputDebugString("Error: Maximum packet size must be greater than or equal to the default packet size\n");
		ReportError("Error: Maximum packet size must be greater than or equal to the default packet size");
		rcode = FALSE;
	}
	// first test that highest is not lower than lowest
	rcode &= bounds_check(cfg_block.lowest_PVC, cfg_block.highest_PVC, "PVC");
	rcode &= bounds_check(cfg_block.lowest_incomming_channel, cfg_block.highest_incomming_channel, "Incoming SVC");
	rcode &= bounds_check(cfg_block.lowest_two_way_channel, cfg_block.highest_two_way_channel, "Two-way SVC");
	rcode &= bounds_check(cfg_block.lowest_outgoing_channel, cfg_block.highest_outgoing_channel, "Outgoing SVC");

	// now check that the ranges do not overlap
	rcode &= overlap_check(cfg_block.lowest_incomming_channel, cfg_block.highest_PVC, "Incoming SVC", "PVC");
	rcode &= overlap_check(cfg_block.lowest_two_way_channel, cfg_block.highest_incomming_channel, "Two-way SVC", "Incoming SVC");
	rcode &= overlap_check(cfg_block.lowest_outgoing_channel, cfg_block.highest_two_way_channel, "Outgoing SVC", "Two-way SVC");

	// check total allocation of channels doesn't exceed 255
	if (!(total_channels_check(&(cfg_block.lowest_PVC)))) {
		ReportError("Error: Total number of configured channels exceeds 255");
//		OutputDebugString("Error: Total number of configured channels exceeds 255\n");
		rcode = FALSE;
	}

	if (!rcode)  ReportError("Configuration may not be saved as is!");

	return(rcode);
}

BOOL bounds_check(WORD low, WORD hi, char *item)
{
	char s[150];

	if (low > hi) {
		sprintf(s, "Error: Highest %s must be greater than or equal to lowest %s", item, item);
		ReportError(s);
		return(FALSE);
	}
	if (low == 0 && hi > 0) {
		sprintf(s, "Error: Highest %s must also be zero if lowest is zero", item);
		ReportError(s);
		return(FALSE);
	}
	if (low > 4095) {
		sprintf(s, "Error: The channel number range for %s must be below 4096", item);
		ReportError(s);
		return(FALSE);
	}
	if (hi > 4095) {
		sprintf(s, "Error: Highest %s must be in the range %u-4095", item, low);
		ReportError(s);
		return(FALSE);
	}
	return(TRUE);
}

BOOL overlap_check(WORD low, WORD hi, char *item1, char *item2)
{
	char s[150];

	if (hi >= low && low > 0) {
		sprintf(s, "Error: Lowest %s must be greater than highest %s", item1, item2);
		ReportError(s);
		return(FALSE);
	}
	return(TRUE);
}

BOOL total_channels_check(WORD *start)
{
	int i;
	WORD low, hi, total;

	total = 0;
	for (i=0; i < 4; i++) {
		low = *(start+(i*2));
		hi = *(start+(i*2)+1);
		if (low != 0) total += (hi-low+1);
	}
	if (total > 255) return(FALSE);
	return(TRUE);
}

void ReportError(char *error)
{
	if (error == NULL)
	{
		if (errorhwn != NULL)
		{
			SendDlgItemMessage(errorhwn, 101, LB_RESETCONTENT, 0, 0L);
		}
		return;
	}
	if (errorhwn == NULL) {
		errorproc = (DLGPROC)MakeProcInstance((FARPROC)ErrorDlg, ghinstance);
		errorhwn = CreateDialog(ghinstance, "ERROR", exehwn, errorproc);
	}
	SendDlgItemMessage(errorhwn, 101, LB_ADDSTRING, 0, (LPARAM)error);
}

void DriverOps(void)
{
	DLGPROC dproc;
	int i;

	dproc = (DLGPROC)MakeProcInstance((FARPROC)DopDlg, ghinstance);
	i=DialogBox(ghinstance, "DRIVOP", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
}

LRESULT CALLBACK DopDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	char s[80];
	UINT i;
	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:  /* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:

		sprintf(DebugString, "DopDlg():WM_INITDIALOG:cfg_block.electrical_interface : 0x%X\n",
			cfg_block.electrical_interface);
		OutputDebugString( DebugString );	

		if(	cfg_block.electrical_interface & 0x80)
		{	CheckDlgButton(hDlg, IDC_RADIO_V35, BST_CHECKED);
			CheckDlgButton(hDlg, IDC_RADIO_RS232, BST_UNCHECKED);
		}else
		{	CheckDlgButton(hDlg, IDC_RADIO_V35, BST_UNCHECKED);
			CheckDlgButton(hDlg, IDC_RADIO_RS232, BST_CHECKED);
		}

		i = (UINT)GetPrivateProfileInt(iniXAPISection, iniTimeoutEntry, 10, our_ini_file);
		SetDlgItemInt(hDlg, 101, i, FALSE);
		i = (UINT)GetPrivateProfileInt(iniXAPISection, iniRetriesEntry, 10, our_ini_file);
		SetDlgItemInt(hDlg, 102, i, FALSE);
		i = (UINT)GetPrivateProfileInt(iniXAPISection, iniTimestampEntry, 1, our_ini_file);
		CheckDlgButton(hDlg, 103, (i!=0) ? 1 : 0);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {

		case 1: //OK button

			if(IsDlgButtonChecked(hDlg, IDC_RADIO_RS232) == BST_CHECKED)
			{	cfg_block.electrical_interface &= (~0x80);
			}else
			{	cfg_block.electrical_interface |= 0x80;
			}

			sprintf(DebugString, "DopDlg():OK button:cfg_block.electrical_interface : 0x%X\n",
				cfg_block.electrical_interface);
			OutputDebugString( DebugString );	

			i = GetDlgItemInt(hDlg, 101, NULL, FALSE);
			sprintf(s, "%u", i);
			WritePrivateProfileString(iniXAPISection, iniTimeoutEntry, s, our_ini_file);
			i = GetDlgItemInt(hDlg, 102, NULL, FALSE);
			sprintf(s, "%u", i);
			WritePrivateProfileString(iniXAPISection, iniRetriesEntry, s, our_ini_file);
			if (IsDlgButtonChecked(hDlg, 103)) i=1; else i=0;
			sprintf(s, "%u", i);
			WritePrivateProfileString(iniXAPISection, iniTimestampEntry, s, our_ini_file);
			EndDialog(hDlg, 0);
			break;
		case 2:
			EndDialog(hDlg, 0);
			break;
		case 3:
			WinHelp(exehwn, helpname, HELP_CONTEXT, 13L);
			activated_help = TRUE;
			break;

		}
	}
	return(0);
}

void WriteTextConfig(void)
{
	OPENFILENAME ofn;
	char filebuffer[128];
	FILE *f;
	int r, off;
	void *ptr;

	memset(&ofn, 0, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);
	ofn.hwndOwner = exehwn;
	ofn.lpstrFilter = logfilter;
	ofn.nFilterIndex = 1;
	ofn.lpstrFile = filebuffer;
	ofn.nMaxFile = 128;
	ofn.lpstrTitle = "Save Configuration in Text Form...";
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_SHOWHELP;
	strcpy(filebuffer, "config.txt");

	if (GetSaveFileName(&ofn)) {
		f = fopen(filebuffer, "w");
		if (f == NULL) {
			MessageBox(exehwn, "Unable to open file for writing!", "File Open Error", MB_OK | MB_ICONHAND);
			return;
		}
		// start writing config to file
		cfg_block.max_I_field_length = 1027;    // just set it
		fprintf(f, "\nConfiguration settings for logical card %u...\n", card);
		fprintf(f, "io_port = %s\n", Sports[cfg_hardware.io_port_index]);
		fprintf(f, "mem_segment = %s\n", Ssegs[cfg_hardware.mem_segment_index]);
		fprintf(f, "mem_window = %c\n", Swins[cfg_hardware.mem_window_index][2]);
		off=0; ptr = &(cfg_block.line_speed_number);
		for (r=0; r < NUM_CONFIG_ENTRIES; r++) {
			switch(byte_or_word[r]) {
			case 0:
				sprintf(filebuffer, "%u", *(((BYTE *)ptr)+off));
				off++;
				break;
			case 1:
				sprintf(filebuffer, "%u", *((WORD *)(((BYTE *)ptr)+off)));
				off+=2;
				break;
			case 2:
				sprintf(filebuffer, "0x%02X", *(((BYTE *)ptr)+off));
				off+=1;
				break;
			case 3:
				sprintf(filebuffer, "0x%04X", *((WORD *)(((BYTE *)ptr)+off)));
				off+=2;
				break;
			}
			fprintf(f, "%s = %s\n", config_fields[r], filebuffer);
		}
		fclose(f);
	}
}

#ifdef MAKEFORNT

char GetRegistryDWordValue(char *keyname, OUT DWORD* value)
{
	char s[100];
	union { DWORD d; BYTE db[4]; } data;
	DWORD size;
	HKEY hkey;

	size = 4;
	data.d = 0;
	sprintf(s, "SYSTEM\\CurrentControlSet\\Services\\SDLA\\Parameters\\sdla%u", card);
	//sprintf(s, "SDLA\\Parameters\\sdla%u\\%s", card, keyname);
	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, s, 0, KEY_QUERY_VALUE, &hkey) != ERROR_SUCCESS){
		return 1;
	}

	if(RegQueryValueEx(hkey, keyname, NULL, NULL, &(data.db[0]), &size) != ERROR_SUCCESS){
		return 2;
	}

	*value = data.d;

	RegCloseKey(hkey);

	return 0;
}

void SetRegistryDWordValue(char *keyname, DWORD value)
{
	char s[100];
	union { DWORD d; BYTE db[4]; } data;
	DWORD size, dummy;
	HKEY hkey;

	size = 4;
	data.d = value;
	sprintf(s, "SYSTEM\\CurrentControlSet\\Services\\SDLA\\Parameters\\sdla%u", card);
	//sprintf(s, "SDLA\\Parameters\\sdla%u\\%s", card, keyname);
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, s, 0, "", REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hkey, &dummy);
	RegSetValueEx(hkey, keyname, 0, REG_DWORD, &(data.db[0]), size);
	RegCloseKey(hkey);
}

BOOL CheckServiceExists(void)
{
	HKEY hkey;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, service_path, 0, KEY_READ, &hkey)
		== ERROR_SUCCESS) { RegCloseKey(hkey); return(TRUE); }
	return(FALSE);
}

BOOL SetServiceKeys(void)
{
	union { DWORD d; BYTE db[4]; } data;
	DWORD size, dummy;
	HKEY hkey;

	size = 4;
	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE, service_path, 0, "", REG_OPTION_NON_VOLATILE, KEY_WRITE, NULL, &hkey, &dummy)
		!= ERROR_SUCCESS) return(FALSE);
	data.d = 1;
	RegSetValueEx(hkey, "ErrorControl", 0, REG_DWORD, &(data.db[0]), size);
	data.d = 2;
	RegSetValueEx(hkey, "Start", 0, REG_DWORD, &(data.db[0]), size);
	data.d = 1;
	RegSetValueEx(hkey, "Type", 0, REG_DWORD, &(data.db[0]), size);
	RegCloseKey(hkey);
	return(TRUE);
}


#endif

/*
void SetOptions(char *ops[], char **sels[], void *defind[], int base)
{
	BYTE i, j;

	if (refresh) {
		for (i=0; i < num_option_windows; i++) {
			DestroyWindow(ops_hwn[i]); ops_hwn[i] = NULL;
			DestroyWindow(sel_hwn[i]); sel_hwn[i] = NULL;
		}
		num_option_windows = 0;
		refresh = FALSE;
	}
	i=0;
	while (ops[i][0] != NULL) {
		if (ops_hwn[i] != NULL) {
			SetWindowText(ops_hwn[i], ops[i]);
			if (i >= num_option_windows) {
				ShowWindow(ops_hwn[i], SW_SHOW);
				ShowWindow(sel_hwn[i], SW_SHOW);
			}
		}
		else {
			ops_hwn[i] = CreateWindow("STATIC", ops[i], WS_CHILD | WS_VISIBLE | SS_RIGHT,
					12, TOP_OP_LINE+3+(i*(title_height+8)), ADJUST(250), 22, exehwn, (HMENU)-1, ghinstance, NULL);
			sel_hwn[i] = CreateWindow("COMBOBOX", "", WS_CHILD | CBS_HASSTRINGS | CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP,
					ADJUST(250)+20, TOP_OP_LINE+(i*(title_height+8)), ADJUST(120), 100,
					exehwn, (HMENU)(base+i), ghinstance, NULL);
		}
		AddSelectables(sel_hwn[i], sels[i], defind[i], base, i);
		if (!IsWindowVisible(sel_hwn[i]))  ShowWindow(sel_hwn[i], SW_SHOWNORMAL);

		storeinfo[i].hwnd = sel_hwn[i];
		storeinfo[i].sel = sels[i];
		storeinfo[i].defs = defind[i];

		i++;
	}
	if (num_option_windows > i) {
		for (j=i; j < num_option_windows; j++) {
			ShowWindow(ops_hwn[j], SW_HIDE);
			ShowWindow(sel_hwn[j], SW_HIDE);
		}
	}
	num_option_windows = i;

}
*/