/* XAPI_M.H - mailbox command codes (x.25 only) */

/* X25 Mailbox commands */
#define	X25_READ		0X22
#define	X25_WRITE		0X23
#define	PLACE_CALL		0X30
#define	ACCEPT_CALL		0X31
#define	CLEAR_CALL		0X32
#define	CONFIRM_CLEAR		0X33
#define	RESET_LOGICAL_CHANNEL	0X34
#define	CONFIRM_RESET		0X35
#define	RESTART			0X36
#define	CONFIRM_RESTART		0X37
#define	INTERRUPT		0X38
#define	CONFIRM_INTERRUPT	0X39
#define	REGISTRATION_REQUEST	0X3a
#define	REGISTRATION_CONFIRMATION	0X3b
#define	IS_DATA_AVAILABLE	0X40
#define	INCOMING_CALL_CONTROL	0X41
#define	CONFIGURE_PVC		0X42
#define	READ_ACTIVE_CHANNELS	0X43
#define	READ_CHANNEL_CONFIGURATION	0X44
#define	FLUSH_X25_DATA_BUFFERS	0X45
#define	READ_X25_HISTORY_TABLE	0X46
#define	X25_HISTORY_TABLE_CONTROL	0X47
#define	READ_X25_STATISTICS	0x49
#define	FLUSH_X25_STATISTICS	0x4a
#define	READ_HDLC_X25_CONFIGURATION	0x50
#define	SET_HDLC_X25_CONFIGURATION	0x51

/* error messages */
#define	NO_BUFFS_OR_CLOSED_WIN	0x33
#define	DATA_LENGTH_TOO_BIG	0x32
#define	NO_DATA_AVAILABLE	0x33

#define	Z80_TIMEOUT_ERROR	0x0a

