/* win95drv.h - header to include in driver user */

#define	MAX_CARDS	16


/*----- RESULT MESSAGES -----*/

#define	SDLAR_NOT_REGISTERED	0L
#define	SDLAR_DEREGISTERED	1L
#define	SDLAR_RELEASED		2L
#define	SDLAR_REGISTERED        1L
#define	SDLAR_ALLOCATED		2L

#define	SDLAR_CARD_BLOCKED	0L
#define	SDLAR_PREPARED		2L
#define	SDLAR_NOT_PREPARED	0L
#define	SDLAR_ERROR_PREPARING	3L

/* if card is not registered and attempt I/O */
/* the value of 10 was chosen arbitrarily, but corresponds to 0x0a timeout */
#define	SDLAR_ILLEGAL_ACCESS	0x8000000aL



// prototypes
void win95drv_initialize(void);
BOOLEAN ObtainMemoryPointer(BYTE cardnumber);
ULONG win95drv_getcards(void);
ULONG win95drv_register(BYTE cardnumber);
ULONG win95drv_deregister(BYTE cardnumber);
ULONG win95drv_preparetoload(BYTE cardnumber);
ULONG win95drv_loadcomplete(BYTE cardnumber);
BYTE win95drv_readbyte(BYTE cardnumber, WORD offset);
void win95drv_writebyte(BYTE cardnumber, WORD offset, BYTE val);
void win95drv_readblock(BYTE cardnumber, WORD src, WORD length, BYTE *dest);
void win95drv_writeblock(BYTE cardnumber, WORD dest, WORD length, BYTE *src);
void win95drv_zerowindow(BYTE cardnumber);
BYTE win95drv_readportbyte(BYTE cardnumber, WORD offset);
void win95drv_writeportbyte(BYTE cardnumber, WORD offset, BYTE val);

